> For the complete documentation index, see [llms.txt](https://docs.nosto.com/magento-2/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.nosto.com/magento-2/addons/cmp/guides/pwa-implementation.md).

# PWA Implementation

It is now possible to use the category merchandising feature in PWA.\
The merchandising rules are applied to the catalog by using the `nosto_personalized` sorting option in products GraphQL query. It comes out of the box from version `>3.1.0` and it does not require any further configuration.

## Filters

CMP module is compatible with Magento 2 GraphQl filtering. You can filter through:

* Price
* Custom attributes (color, size etc.)
* Brand

## Query example

```
{
  products(
    filter: { 
      category_id: { eq: "4" },
      price: {
        from: "10",
        to: "100"
      },
      color: {
        in: [ "49", "50" ]
      },
      eco: {
        eq: true
      }
    }
    currentPage: 1
    pageSize: 5
    sort: {nosto_personalized: DESC}
  ) {
    total_count
    items {
      name
      sku
      price_range {
        minimum_price {
          regular_price {
            value
            currency
          }
        }
      }
    }
    page_info {
      page_size
      current_page
    }
  }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.nosto.com/magento-2/addons/cmp/guides/pwa-implementation.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
